Index: palm/trunk/SOURCE/package_parin.f90
===================================================================
--- palm/trunk/SOURCE/package_parin.f90	(revision 1787)
+++ palm/trunk/SOURCE/package_parin.f90	(revision 1788)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Parameter dewfall removed.
 !
 ! Former revisions:
@@ -129,12 +129,13 @@
     USE land_surface_model_mod,                                                &
         ONLY: alpha_vangenuchten, c_surface, canopy_resistance_coefficient,    &
-              conserve_water_content, dewfall, field_capacity,                 &
+              conserve_water_content, field_capacity,                          &
               f_shortwave_incoming, hydraulic_conductivity,                    &
               lambda_surface_stable, lambda_surface_unstable, leaf_area_index, &
               land_surface, l_vangenuchten, min_canopy_resistance,             &
-              min_soil_resistance, n_vangenuchten, residual_moisture,          &
+              min_soil_resistance, n_vangenuchten, pave_heat_capacity,         &
+              pave_depth, pave_heat_conductivity, residual_moisture,           &
               root_fraction, saturation_moisture, wilting_point,               &
               skip_time_do_lsm, soil_moisture, soil_temperature, soil_type,    &
-              vegetation_coverage, veg_type, zs, z0_eb, z0h_eb
+              vegetation_coverage, veg_type, zs, z0_eb, z0h_eb, z0q_eb
 
     USE kinds
@@ -205,5 +206,5 @@
     NAMELIST /lsm_par/            alpha_vangenuchten, c_surface,               &
                                   canopy_resistance_coefficient,               &
-                                  conserve_water_content, dewfall,             &
+                                  conserve_water_content,                      &
                                   f_shortwave_incoming, field_capacity,        & 
                                   hydraulic_conductivity,                      &
@@ -212,9 +213,11 @@
                                   l_vangenuchten, min_canopy_resistance,       &
                                   min_soil_resistance, n_vangenuchten,         &
+                                  pave_depth, pave_heat_capacity,              &
+                                  pave_heat_conductivity,                      &
                                   residual_moisture, root_fraction,            &
                                   saturation_moisture, skip_time_do_lsm,       &
                                   soil_moisture, soil_temperature, soil_type,  &
                                   vegetation_coverage, veg_type, wilting_point,& 
-                                  zs, z0_eb, z0h_eb
+                                  zs, z0_eb, z0h_eb, z0q_eb
 
 
Index: palm/trunk/SOURCE/radiation_model.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model.f90	(revision 1787)
+++ palm/trunk/SOURCE/radiation_model.f90	(revision 1788)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added new albedo class for pavements / roads.
 !
 ! Former revisions:
@@ -112,4 +112,8 @@
 
 #if defined ( __rrtmg )
+
+!     USE netcdf_interface,                                                      &
+!         ONLY:  nc_stat, netcdf_handle_error
+
     USE parrrsw,                                                               &
         ONLY:  naerec, nbndsw
@@ -139,5 +143,5 @@
 !
 !-- Predefined Land surface classes (albedo_type) after Briegleb (1992)
-    CHARACTER(37), DIMENSION(0:16), PARAMETER :: albedo_type_name = (/      &
+    CHARACTER(37), DIMENSION(0:17), PARAMETER :: albedo_type_name = (/      &
                                    'user defined                         ', & !  0 
                                    'ocean                                ', & !  1
@@ -156,5 +160,6 @@
                                    'land ice                             ', & ! 14 
                                    'sea ice                              ', & ! 15 
-                                   'snow                                 '  & ! 16
+                                   'snow                                 ', & ! 16
+                                   'pavement/roads                       '  & ! 17
                                                          /)
 
@@ -163,9 +168,4 @@
                     day_init     = 172,  & !< day of the year at model start (21/06)
                     dots_rad     = 0       !< starting index for timeseries output 
-
-
-
-
-
 
     LOGICAL ::  unscheduled_radiation_calls = .TRUE., & !< flag parameter indicating whether additional calls of the radiation code are allowed
@@ -214,5 +214,5 @@
 !-- Land surface albedos for solar zenith angle of 60Â° after Briegleb (1992)     
 !-- (shortwave, longwave, broadband):   sw,      lw,      bb,
-    REAL(wp), DIMENSION(0:2,1:16), PARAMETER :: albedo_pars = RESHAPE( (/& 
+    REAL(wp), DIMENSION(0:2,1:17), PARAMETER :: albedo_pars = RESHAPE( (/& 
                                    0.06_wp, 0.06_wp, 0.06_wp,            & !  1
                                    0.09_wp, 0.28_wp, 0.19_wp,            & !  2
@@ -230,6 +230,7 @@
                                    0.90_wp, 0.65_wp, 0.77_wp,            & ! 14
                                    0.90_wp, 0.65_wp, 0.77_wp,            & ! 15
-                                   0.95_wp, 0.70_wp, 0.82_wp             & ! 16
-                                 /), (/ 3, 16 /) )
+                                   0.95_wp, 0.70_wp, 0.82_wp,            & ! 16
+                                   0.08_wp, 0.08_wp, 0.08_wp             & ! 17
+                                 /), (/ 3, 17 /) )
 
     REAL(wp), DIMENSION(:,:,:), ALLOCATABLE, TARGET :: &
@@ -275,4 +276,6 @@
                     rrtm_iaer = 0,     & !< aerosol option flag (0: no aerosol layers, for lw only: 6 (requires setting of rrtm_sw_ecaer), 10: one or more aerosol layers (not implemented)
                     rrtm_idrv = 1        !< longwave upward flux calculation option (0,1)
+
+    INTEGER(iwp) :: nc_stat !< local variable for storin the result of netCDF calls for error message handling
 
     LOGICAL :: snd_exists = .FALSE.      !< flag parameter to check whether a user-defined input files exists
@@ -1030,4 +1033,10 @@
                  rrtm_aldir(0,:,:) = aldif
                  rrtm_asdir(0,:,:) = asdif
+
+!
+!--        Asphalt
+           ELSEIF ( albedo_type == 17 )  THEN
+                 rrtm_aldir(0,:,:) = aldif
+                 rrtm_asdir(0,:,:) = asdif
 !
 !--        Land surfaces
Index: palm/trunk/SOURCE/read_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/read_3d_binary.f90	(revision 1787)
+++ palm/trunk/SOURCE/read_3d_binary.f90	(revision 1788)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added z0q and z0q_av
 ! 
 ! Former revisions:
@@ -97,5 +97,5 @@
                rif_wall, shf, ts, tswst, u, u_m_l, u_m_n, u_m_r, u_m_s, us,    &
                usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, vsws, vswst,   &
-               w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h
+               w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h, z0q
 
     USE averaging
@@ -354,5 +354,5 @@
 !--    First compare the version numbers
        READ ( 13 )  version_on_file
-       binary_version = '4.2'
+       binary_version = '4.3'
        IF ( TRIM( version_on_file ) /= TRIM( binary_version ) )  THEN
           WRITE( message_string, * ) 'version mismatch concerning data ',      &
@@ -1358,4 +1358,17 @@
                    IF ( k == 1 )  READ ( 13 )  tmp_2d
                    z0h_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                       tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'z0q' )
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   z0q(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
+                     tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'z0q_av' )
+                   IF ( .NOT. ALLOCATED( z0q_av ) )  THEN
+                      ALLOCATE( z0q_av(nysg:nyng,nxlg:nxrg) )
+                   ENDIF
+                   IF ( k == 1 )  READ ( 13 )  tmp_2d
+                   z0q_av(nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp)  = &
                        tmp_2d(nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
Index: palm/trunk/SOURCE/sum_up_3d_data.f90
===================================================================
--- palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1787)
+++ palm/trunk/SOURCE/sum_up_3d_data.f90	(revision 1788)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added z0q and z0q_av
 ! 
 ! Former revisions:
@@ -92,5 +92,5 @@
     USE arrays_3d,                                                             &
         ONLY:  dzw, e, nr, ol, p, pt, q, qc, ql, ql_c, ql_v, qr, qsws, rho, sa,&
-               shf, ts, u, us, v, vpt, w, z0, z0h
+               shf, ts, u, us, v, vpt, w, z0, z0h, z0q
 
     USE averaging,                                                             &
@@ -98,5 +98,6 @@
                precipitation_rate_av, pt_av, q_av, qc_av, ql_av, ql_c_av,      &
                ql_v_av, ql_vp_av, qr_av, qsws_av, qv_av, rho_av, s_av, sa_av,  &
-               shf_av, ts_av, u_av, us_av, v_av, vpt_av, w_av, z0_av, z0h_av
+               shf_av, ts_av, u_av, us_av, v_av, vpt_av, w_av, z0_av, z0h_av,  &
+               z0q_av
 
     USE cloud_parameters,                                                      &
@@ -494,4 +495,10 @@
                 ENDIF
                 z0h_av = 0.0_wp
+
+             CASE ( 'z0q*' )
+                IF ( .NOT. ALLOCATED( z0q_av ) )  THEN
+                   ALLOCATE( z0q_av(nysg:nyng,nxlg:nxrg) )
+                ENDIF
+                z0q_av = 0.0_wp
 
              CASE DEFAULT
@@ -1006,4 +1013,11 @@
              ENDDO
 
+          CASE ( 'z0q*' )
+             DO  i = nxlg, nxrg
+                DO  j = nysg, nyng
+                   z0q_av(j,i) = z0q_av(j,i) + z0q(j,i)
+                ENDDO
+             ENDDO
+
           CASE DEFAULT
 !
Index: palm/trunk/SOURCE/surface_layer_fluxes.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes.f90	(revision 1787)
+++ palm/trunk/SOURCE/surface_layer_fluxes.f90	(revision 1788)
@@ -19,5 +19,7 @@
 ! Current revisions:
 ! ------------------
-! 
+! Added parameter z0q which replaces z0h in the similarity functions for
+! humidity.
+! Syntax layout improved.
 ! 
 ! Former revisions:
@@ -117,5 +119,5 @@
     USE arrays_3d,                                                             &
         ONLY:  e, kh, nr, nrs, nrsws, ol, pt, q, ql, qr, qrs, qrsws, qs, qsws, &
-               shf, ts, u, us, usws, v, vpt, vsws, zu, zw, z0, z0h
+               shf, ts, u, us, usws, v, vpt, vsws, zu, zw, z0, z0h, z0q
 
     USE cloud_parameters,                                                      &
@@ -234,5 +236,5 @@
 !--    Use either Newton iteration or a lookup table for the bulk Richardson
 !--    number to calculate the Obukhov length 
-       ELSEIF ( most_method == 'newton' .OR. most_method == 'lookup' )  THEN
+       ELSEIF ( most_method == 'newton'  .OR.  most_method == 'lookup' )  THEN
 
           CALL calc_uv_total
@@ -302,5 +304,5 @@
 !--       Check for roughness heterogeneity. In that case terminate run and
 !--       inform user
-          IF ( MINVAL( z0h ) /= MAXVAL( z0h ) .OR.                             &
+          IF ( MINVAL( z0h ) /= MAXVAL( z0h )  .OR.                            &
                MINVAL( z0  ) /= MAXVAL( z0  ) )  THEN
              terminate_run_l = .TRUE.
@@ -347,5 +349,5 @@
 !
 !--       Calculate stretching factor for the free convection range
-          DO WHILE ( ABS( (regr-regr_old) / regr_old ) > 1.0E-10_wp )
+          DO  WHILE ( ABS( (regr-regr_old) / regr_old ) > 1.0E-10_wp )
              regr_old = regr
              regr = ( 1.0_wp - ( -zeta_min / zeta_step ) * ( 1.0_wp - regr )   &
@@ -533,5 +535,5 @@
 !--             Ensure that the bulk Richardson number and the Obukhov 
 !--             lengtH have the same sign
-                IF ( rib(j,i) * ol(j,i) < 0.0_wp .OR.                        &
+                IF ( rib(j,i) * ol(j,i) < 0.0_wp  .OR.                         &
                      ABS( ol(j,i) ) == ol_max )  THEN
                    IF ( rib(j,i) > 0.0_wp ) ol(j,i) =  0.01_wp
@@ -638,5 +640,5 @@
 
           !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          !# WARNING: does not work on GPU so far because of DO WHILE construct
+          !# WARNING: does not work on GPU so far because of DO  WHILE construct
           !!!!!!$acc kernels loop
           DO  i = nxl, nxr
@@ -656,10 +658,10 @@
                 l = l_bnd
                 IF ( rib_tab(l) - rib(j,i) > 0.0_wp )  THEN
-                   DO WHILE ( rib_tab(l-1) - rib(j,i) > 0.0_wp .AND. l > 0 )
+                   DO  WHILE ( rib_tab(l-1) - rib(j,i) > 0.0_wp  .AND.  l > 0 )
                       l = l-1
                    ENDDO
                 ELSE
-                   DO WHILE ( rib_tab(l) - rib(j,i) < 0.0_wp                &
-                              .AND. l < num_steps-1 )
+                   DO  WHILE ( rib_tab(l) - rib(j,i) < 0.0_wp                  &
+                              .AND.  l < num_steps-1 )
                       l = l+1
                    ENDDO
@@ -669,6 +671,6 @@
 !
 !--             Linear interpolation to find the correct value of z/L
-                ol(j,i) = ( ol_tab(l-1) + ( ol_tab(l) - ol_tab(l-1) )       &
-                            / (  rib_tab(l) - rib_tab(l-1) )                &
+                ol(j,i) = ( ol_tab(l-1) + ( ol_tab(l) - ol_tab(l-1) )          &
+                            / (  rib_tab(l) - rib_tab(l-1) )                   &
                             * ( rib(j,i) - rib_tab(l-1) ) )
 
@@ -797,5 +799,5 @@
 !
 !--       For a given surface temperature:
-          IF ( large_scale_forcing .AND. lsf_surf )  THEN
+          IF ( large_scale_forcing  .AND.  lsf_surf )  THEN
              !$OMP PARALLEL DO
              !$acc kernels loop private( j, k )
@@ -837,5 +839,5 @@
           IF ( constant_waterflux )  THEN
 !
-!--          For a given water flux in the Prandtl layer:
+!--          For a given water flux in the surface layer
              !$OMP PARALLEL DO
              !$acc kernels loop private( j )
@@ -847,8 +849,8 @@
 
           ELSE
-             coupled_run = ( coupling_mode == 'atmosphere_to_ocean' .AND.      &
+             coupled_run = ( coupling_mode == 'atmosphere_to_ocean'  .AND.     &
                              run_coupled )
 
-             IF ( large_scale_forcing .AND. lsf_surf )  THEN
+             IF ( large_scale_forcing  .AND.  lsf_surf )  THEN
                 !$OMP PARALLEL DO
                 !$acc kernels loop private( j, k )
@@ -862,5 +864,5 @@
 
              !$OMP PARALLEL DO PRIVATE( e_s, k, z_mo )
-             !$acc kernels loop independent present( nzb_s_inner, ol, pt, q, qs, qv1, zu, zw, z0h ) private( e_s, j, k, z_mo )
+             !$acc kernels loop independent present( nzb_s_inner, ol, pt, q, qs, qv1, zu, zw, z0q ) private( e_s, j, k, z_mo )
              DO  i = nxlg, nxrg
                 !$acc loop independent
@@ -882,13 +884,13 @@
                    IF ( cloud_physics )  THEN
                       qs(j,i) = kappa * ( qv1(j,i) - q(k,j,i) )                &
-                                        / ( LOG( z_mo / z0h(j,i) )             &
+                                        / ( LOG( z_mo / z0q(j,i) )             &
                                             - psi_h( z_mo / ol(j,i) )          &
-                                            + psi_h( z0h(j,i) / ol(j,i) ) )
+                                            + psi_h( z0q(j,i) / ol(j,i) ) )
 
                    ELSE
                       qs(j,i) = kappa * ( q(k+1,j,i) - q(k,j,i) )              &
-                                        / ( LOG( z_mo / z0h(j,i) )             &
+                                        / ( LOG( z_mo / z0q(j,i) )             &
                                             - psi_h( z_mo / ol(j,i) )          &
-                                            + psi_h( z0h(j,i) / ol(j,i) ) )
+                                            + psi_h( z0q(j,i) / ol(j,i) ) )
                    ENDIF
 
@@ -901,8 +903,9 @@
 !
 !--    If required compute qr* and nr*
-       IF ( cloud_physics .AND. icloud_scheme == 0 .AND. precipitation )  THEN
+       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  precipitation )   &
+       THEN
 
           !$OMP PARALLEL DO PRIVATE( k, z_mo )
-          !$acc kernels loop independent present( nr, nrs, nzb_s_inner, ol, qr, qrs, zu, zw, z0h ) private( j, k, z_mo )
+          !$acc kernels loop independent present( nr, nrs, nzb_s_inner, ol, qr, qrs, zu, zw, z0q ) private( j, k, z_mo )
           DO  i = nxlg, nxrg
              !$acc loop independent
@@ -913,12 +916,12 @@
 
                 qrs(j,i) = kappa * ( qr(k+1,j,i) - qr(k,j,i) )              &
-                                 / ( LOG( z_mo / z0h(j,i) )                 &
+                                 / ( LOG( z_mo / z0q(j,i) )                 &
                                      - psi_h( z_mo / ol(j,i) )              &
-                                     + psi_h( z0h(j,i) / ol(j,i) ) )
+                                     + psi_h( z0q(j,i) / ol(j,i) ) )
 
                 nrs(j,i) = kappa * ( nr(k+1,j,i) - nr(k,j,i) )              &
-                                 / ( LOG( z_mo / z0h(j,i) )                 &
+                                 / ( LOG( z_mo / z0q(j,i) )                 &
                                      - psi_h( z_mo / ol(j,i) )              &
-                                     + psi_h( z0h(j,i) / ol(j,i) ) )
+                                     + psi_h( z0q(j,i) / ol(j,i) ) )
              ENDDO
           ENDDO
@@ -1003,6 +1006,6 @@
 !
 !--    Compute the vertical kinematic heat flux
-       IF ( .NOT. constant_heatflux .AND. ( simulated_time <=                &
-            skip_time_do_lsm .OR. .NOT. land_surface ) )  THEN
+       IF (  .NOT.  constant_heatflux .AND.  ( simulated_time <=               &
+            skip_time_do_lsm  .OR.  .NOT.  land_surface ) )  THEN
           !$OMP PARALLEL DO
           !$acc kernels loop independent present( shf, ts, us )
@@ -1018,7 +1021,7 @@
 !
 !-- Compute the vertical water/scalar flux
-       IF ( .NOT. constant_waterflux .AND. ( humidity .OR. passive_scalar )    &
-            .AND. ( simulated_time <= skip_time_do_lsm .OR. .NOT.            &
-            land_surface ) )  THEN
+       IF (  .NOT.  constant_waterflux  .AND.  ( humidity  .OR.                &
+             passive_scalar )  .AND.  ( simulated_time <= skip_time_do_lsm     &
+            .OR.  .NOT.  land_surface ) )  THEN
           !$OMP PARALLEL DO
           !$acc kernels loop independent present( qs, qsws, us )
@@ -1089,5 +1092,5 @@
 
        IF ( zeta < 0.0_wp )  THEN
-          x = SQRT( SQRT(1.0_wp  - 16.0_wp * zeta ) )
+          x = SQRT( SQRT( 1.0_wp  - 16.0_wp * zeta ) )
           psi_m = pi * 0.5_wp - 2.0_wp * ATAN( x ) + LOG( ( 1.0_wp + x )**2    &
                   * ( 1.0_wp + x**2 ) * 0.125_wp )
@@ -1126,5 +1129,5 @@
 
        IF ( zeta < 0.0_wp )  THEN
-          x = SQRT(1.0_wp  - 16.0_wp * zeta )
+          x = SQRT( 1.0_wp  - 16.0_wp * zeta )
           psi_h = 2.0_wp * LOG( (1.0_wp + x ) / 2.0_wp )
        ELSE
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 1787)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 1788)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Added z0q and z0q_av
 ! 
 ! Former revisions:
@@ -90,5 +90,5 @@
                rif_wall, shf, ts, tswst, u, u_m_l, u_m_n, u_m_r, u_m_s, us,    &
                usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, vsws, vswst,   &
-               w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h
+               w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h, z0q
         
     USE averaging
@@ -142,5 +142,5 @@
 !
 !-- Write arrays.
-    binary_version = '4.2'
+    binary_version = '4.3'
 
     WRITE ( 14 )  binary_version
@@ -470,4 +470,8 @@
        WRITE ( 14 )  'z0h_av              ';  WRITE ( 14 )  z0h_av
     ENDIF
+    WRITE ( 14 )  'z0q                 ';  WRITE ( 14 )  z0q
+    IF ( ALLOCATED( z0q_av ) )  THEN
+       WRITE ( 14 )  'z0q_av              ';  WRITE ( 14 )  z0q_av
+    ENDIF
 
 !
